
                                                                                // Lcd module connections
sbit LCD_RS at LATB2_bit;
sbit LCD_EN at LATB3_bit;
sbit LCD_D4 at LATB4_bit;
sbit LCD_D5 at LATB5_bit;
sbit LCD_D6 at LATB6_bit;
sbit LCD_D7 at LATB7_bit;

sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;
                                                                                // End Lcd module connections
char *string;                                                                   // Pointer to String
int i,j;
char txt[1024];
unsigned int ready = 0;
char latitude[11], longitude[12];
float lat,lon,lon_dec,lat_dec,rem;
char lat_t[11], long_t[11];
char hours[3], min[3],sec[3];
char test[2];
char gpgll[]="$GPGLL";
float *lon_convert;

void INTERRUPT_UART2_RX() iv IVT_ADDR_U2RXINTERRUPT {

 while (Uart2_Data_Ready()) {
   txt[i] = Uart2_Read();
   i++;
   }

 if (i>500){
  ready=1;                                                                       //set data as available
  U2RXIE_bit=0;
 }

 U2STA.OERR= 0;                                                                 //set OERR status bit to 0
 U2STA.FERR= 0;                                                                 //set FERRR status bit to 0
 U2RXIF_bit=0;                                                                  //Clear Receive Interrupt Flag

}

void main() {

 ADPCFG = 0xFFFF;                                                               // Set AN pins to Digital I/O
 ready = 0;
 i=0;

 LCD_init();                                                                    // Initialise LCD module
 Delay_ms(100);                                                                 // Wait 100ms

 U2RXIF_bit=0;

 Uart2_Init(9600);                                                              // Initialize UART module
 Delay_ms(100);

 U2RXIE_bit=1;

 while (1) {
 
  if(ready == 1) {                                                              // if the data in txt array is ready process.

   ready = 0;                                                                   // Clear the ready flag
   string=0x00;                                                                 // Clear the string pointer
   string = strstr(txt,gpgll);                                                  // Search for $GPGLL and assign string pointer
   
   if(string != 0) {                                                            // If txt array contains "$GPGLL"

    if(string[7] != ',') {                                                      // If the 7th character is not a comma, data has been received (consider changing to valid signal)

     memset(latitude,0x00,11);                                                  // Clear Latitude String
     memset(longitude,0x00,12);                                                 // Clear Longitude String
     memset(hours,0x00,3);                                                      // Clear Hours
     memset(min,0x00,3);                                                        //Clear Minutes
     memset(sec,0x00,3);                                                        //Clear Second
     
     string = strstr(txt,gpgll);                                                //
     memcpy(latitude,string+7,10);                                              // Copy Longitude
     memcpy(longitude,string+20,11);                                            // Copy Latitude
     memcpy(hours,string+34,2);                                                 // Copy Hours
     memcpy(min,string+36,2);                                                   // Copy Minutes
     memcpy(sec,string+38,2);                                                   //Copy

     lat=0;
     lon=0;

     lat_dec=(latitude[2]-48)*1000000+(latitude[3]-48)*100000+(latitude[5]-48)*10000+(latitude[6]-48)*1000+(latitude[7]-48)*100+(latitude[8]-48)*10+(latitude[9]-48);
     lon_dec=(longitude[3]-48)*1000000+(longitude[4]-48)*100000+(longitude[6]-48)*10000+(longitude[7]-48)*1000+(longitude[8]-48)*100+(longitude[9]-48)*10+(longitude[10]-48);
     lon_dec=lon_dec/6000;
     //rem=modf(lon_dec,lon_convert);
     
     lat=(latitude[0]-48)*10+(latitude[1]-48)+lat_dec/6000000;           // -48 to convert from ASCII number to regular number
     lon=(longitude[0]-48)*100+(longitude[1]-48)*10+(longitude[2]-48)+lon_dec/1000;        // -48 to convert from ASCII number to regular number

     if (string[18]=='S'){                                                      // South is negative
     lat=0-lat;
     }
     
     if (string[32]=='W'){                                                      //West is negative
     lon=0-lon;
     }
     
     floattostr(lat,lat_t);
     floattostr(lon,long_t);

     lcd_cmd(_lcd_clear);                                                       // if "$GPGLL" NMEA message have ',' sign in the 8-th
     lcd_cmd(_LCD_CURSOR_OFF);
     lcd_out(1,1,"Lat:");
     lcd_out(1,6,lat_t);
     lcd_out(2,1,"Long:");
     lcd_out(2,6,long_t);
     delay_ms(2000);
     lcd_cmd(_lcd_clear);
     lcd_out(1,1,"GPS Time:");
     lcd_out(2,1,hours);
     lcd_out(2,3,":");
     lcd_out(2,4,min);
     lcd_out(2,6,":");
     lcd_out(2,7,sec);
     delay_ms(2000);
    }
   }
  }
  if (i>700){                                                                   //If most of the NMEA data has been read, then clear the txt counter and clear the memory
  i=0;
  memset(txt,0x00,1023);
  }
  U2RXIE_bit=1;                                                                 //Enable UART 2 Receive Interrupt
 }
}